
//
//  Copyright:       (C) International Business Machines Corporation, 1998
//
//  Project Des:     Netfinity STORAGE Management
//
//  Module Name:     StorageBaseNetRMI.java
//
//  Description:     
//
//  Revision(s):  Title - Description                                           Author               Tag        Date
//          
//     0.0.0      Creation                                                      Kevin L. Scheiern               07/23/98
//
package com.ibm.sysmgt.storage.net;
//Ĵ Imports 
import java.lang.*;
import java.io.*;
import java.util.*;
import com.ibm.sysmgt.storage.api.*;
//
//                                         Class StorageBaseNetRMI
//
public class StorageBaseNetRMI extends StorageData implements StorageNET_API, Cloneable, Serializable
{
    private LVal           olFailId;                         // Initialized to failure by the constructor.
    private StorageBaseNet oNet;
 //ͻ
 //͹
 //                                      Construction and Destruction Methods                                         
 //͹
 //ͼ
    public             StorageBaseNetRMI( StorageBaseNet oBaseNet )      // Constructor
                       {
                          oNet = oBaseNet;                               // Capture this pointer of parent object

                          olFailId = new LVal( -999999999 );             // Initialize to Failure

                          olFailId = new LVal( 0 );                      // OK, set failure ID to pass.
                       }

    protected void     finalize()
                       {
                       }

    public    boolean  BaseNetRMIConstructorOK( LVal olFailID )
                       {
                          if ( 0 != olFailId.l.intValue() ) return false; // First, did I construct OK

                          return true;                                    // If yes, then check downstream constructions
                       }
 //ͻ
 //͹
 //͹
 //                                                 DLL API's                                                         
 //͹
 //͹
 //ͼ
    public    boolean  DLLConstructorOK( LVal olFailID )
                       {
                          return ( oNet.DLLConstructorOK( olFailID ) );          
                       }

    public    int      GetDLLType( DllType oDllType )
                       {
                          return ( oNet.GetDLLType( oDllType ) );
                       }

    public    int      GetDLLVersion( Version oVersion )
                       {
                          return ( oNet.GetDLLVersion( oVersion ) );
                       }

    public    int      GetDLLIntfVersion( Version oVersion )
                       {
                          return ( oNet.GetDLLIntfVersion( oVersion ) );
                       }

    public    int      GetAddressScheme( StorAddr oMapAddr )
                       {
                          return ( oNet.GetAddressScheme( oMapAddr ) );
                       }

    public    int      GetMaxValues( MaxAddr oMaxAddr )
                       {
                          return ( oNet.GetMaxValues( oMaxAddr ) );
                       }

    public    int      GetDeviceDriverVersion( Version oVersion ) 
                       {
                          return ( oNet.GetDeviceDriverVersion( oVersion ) );
                       }

 //ͻ
 //͹
 //                                             StorageCmnd Methods                                                   
 //͹
 //ͼ
    public    StorRet  IsStoragePresent( BlVal oblPresent )         // Is there one or more supported Storage
                       {
                          return ( oNet.IsStoragePresent( oblPresent ) ); 
                       }
                                                                    // Adapters present and useable
    public    int      GetStorageIntfVersion( Version oVersion )    // Do NOT override this method
                       {
                          return ( oNet.GetStorageIntfVersion( oVersion ) );                
                       }
 //
 //                    StorageCmnd Configuration Access Methods
 //
                       // Execute Adapter Diagnostics
    public    StorRet  ExecuteAdapterDiagnostics( StorAddr oAdapAddr, long lDiagTestNum, long lLoopCount ) 
                       {
                          return ( oNet.ExecuteAdapterDiagnostics( oAdapAddr, lDiagTestNum, lLoopCount ) );
                       }

    public    StorRet  SetAdapChanInitID( StorAddr oChanAddr, long lInitiatorID ) 
                       {
                          return ( oNet.SetAdapChanInitID( oChanAddr, lInitiatorID ) );
                       }

    public    StorRet  BatteryBackupCache( StorAddr oAdapAddr, boolean blEnable ) 
                       {
                          return ( oNet.BatteryBackupCache( oAdapAddr, blEnable ) );
                       }

                       // 0 = Reserved, 1 = Standard CHS Mode, 2 = Enhanced CHS Mode
    public    StorRet  SetBiosMappingMode( StorAddr oAdapAddr, short sBiosMode ) 
                       {
                          return ( oNet.SetBiosMappingMode( oAdapAddr, sBiosMode ) );
                       }

                       // Delay is specified in seconds
    public    StorRet  MaxSimultaneousDevSpinUp( StorAddr oDevAddr, long lMaxSpinUpCount, long lDelayBetweenGroups ) 
                       {
                          return ( oNet.MaxSimultaneousDevSpinUp( oDevAddr, lMaxSpinUpCount, lDelayBetweenGroups ) );
                       }

                       // Execute Device Diagnostics
    public    StorRet  ExecuteDeviceDiagnostics( StorAddr oDevAddr, long ulDiagTestNum, long ulLoopCount ) 
                       {
                          return ( oNet.ExecuteDeviceDiagnostics( oDevAddr, ulDiagTestNum, ulLoopCount ) );
                       }

                       // This is a low-level SCSI Format
    public    StorRet  FormatDevice( StorAddr oDevAddr ) 
                       {
                          return ( oNet.FormatDevice( oDevAddr ) );
                       }

    public    StorRet  SetDevXferSpeed( StorAddr oChanAddr, long lMhzSpeed ) 
                       {
                          return ( oNet.SetDevXferSpeed( oChanAddr, lMhzSpeed ) );
                       }
 //
 //                    StorageCmnd Adapter Access Methods
 //
                       // Get the supported Adapter Count
    public    StorRet  SupportedAdapterCount( StorAddr oSubSysAddr, AddrList oAdapAddrList ) 
                       {
                          return ( oNet.SupportedAdapterCount( oSubSysAddr, oAdapAddrList ) );
                       }

                       // Return adapter status
    public    StorRet  AdapterStatus( StorAddr oAdapAddr, AdapterStatus oAdapStatus ) 
                       {
                          return ( oNet.AdapterStatus( oAdapAddr, oAdapStatus ) );
                       }

                       // Return adapter information
    public    StorRet  AdapterInfo( StorAddr oAdapAddr, AdapterInfo oAdapInfo ) 
                       {
                          return ( oNet.AdapterInfo( oAdapAddr, oAdapInfo ) );
                       }

                       // Return Channel Info
    public    StorRet  ChannelInfo( StorAddr oChanAddr, ChannelInfo oChanInfo ) 
                       {
                          return ( oNet.ChannelInfo( oChanAddr, oChanInfo ) );
                       }

                       // Update Adapter BIOS
    public    StorRet  UpdateAdapterBios( StorAddr oAdapAddr, ByteBlk oBiosData ) 
                       {
                          return ( oNet.UpdateAdapterBios( oAdapAddr, oBiosData ) );
                       }

                       // Update Adapter Firmware
    public    StorRet  UpdateAdapterFirmWare( StorAddr oAdapAddr, ByteBlk oFirmWareData ) 
                       {
                          return ( oNet.UpdateAdapterFirmWare( oAdapAddr, oFirmWareData ) );
                       }

                       // Sends a Generic Command to the Adapter
    public    StorRet  ExecAdapterCmnd( StorAddr oAdapAddr,      //  1. Adapter Address
                                        CmndBlk  oCmndBlock,     //  2. Adapter Command Byte Block 
                                        ByteBlk  oInputBlock,    //  3. Input  Buffer Byte Block
                                        ByteBlk  oOutputBlock,   //  4. Output Buffer Byte Block
                                        ByteBlk  oStatusBlock,   //  5. Status Buffer Byte Block
                                        long     lTimeOut,       //  6. Timeout in Seconds (Assumes 60 ) 
                                        long     lRetry,         //  7. Retry Count        (Assumes None)
                                        boolean  blXferDirIn,    //  8. Transfer Direction (Assumes In)
                                        boolean  blStatReq       //  9. Status Requested (Assumes No)
                                      ) 
                       {
                          return ( oNet.ExecAdapterCmnd( oAdapAddr, oCmndBlock, oInputBlock, oOutputBlock, oStatusBlock,
                                                         lTimeOut,  lRetry,     blXferDirIn, blStatReq       
                                                       )
                                 );
                       }
 //
 //                    Storage Device Access Methods
 //
                       // Get the device count for the specified channel 
    public    StorRet  ChannelDeviceCount(  StorAddr oChanAddr, AddrList oDevAddrList ) 
                       {
                          return ( oNet.ChannelDeviceCount( oChanAddr, oDevAddrList ) );
                       }

                       // Get the device rollup count for ALL channels for the specified Adapter
    public    StorRet  AdapterDeviceCount( StorAddr oAdapAddr, IVal oiAdapDevCount ) 
                       {
                          return ( oNet.AdapterDeviceCount( oAdapAddr, oiAdapDevCount ) );
                       }

                       // Get the type for the specified device
    public    StorRet  DeviceType( StorAddr oDevAddr, IVal oiDevType ) 
                       {
                          return ( oNet.DeviceType( oDevAddr, oiDevType ) );
                       }

                       // Get the device capacity for the specified device
    public    StorRet  DeviceCapacity( StorAddr oDevAddr, DeviceSize oDevSize ) 
                       {
                          return ( oNet.DeviceCapacity( oDevAddr, oDevSize ) );
                       }

                       // Return Device Info
    public    StorRet  DeviceInfo( StorAddr oDevAddr, DeviceInfo oDevInfo ) 
                       {
                          return ( oNet.DeviceInfo( oDevAddr, oDevInfo ) );
                       }

                       // Update Device Firmware
    public    StorRet  UpdateDeviceFirmWare( StorAddr oDevAddr, ByteBlk oFirmWareData ) 
                       {
                          return ( oNet.UpdateDeviceFirmWare( oDevAddr, oFirmWareData ) );
                       }

    public    StorRet  PFADevice( StorAddr oDevAddr, BlVal oblPfaEventOccurred, LVal olPfaEventCodes ) 
                       {
                          return ( oNet.PFADevice( oDevAddr, oblPfaEventOccurred, olPfaEventCodes ) );
                       }

                       // Sends a Generic Command to the Device
    public    StorRet  ExecDeviceCmnd( StorAddr  oDevAddr,            //  1. Device Address
                                        CmndBlk  oCmndBlock,          //  2. Device Command Byte Block 
                                        ByteBlk  oInputBlock,         //  3. Input  Buffer Byte Block
                                        ByteBlk  oOutputBlock,        //  4. Output Buffer Byte Block
                                        ByteBlk  oStatusBlock,        //  5. Status Buffer Byte Block
                                        long     lTimeOut,            //  6. Timeout in Seconds (Assumes 60 ) 
                                        long     lRetry,              //  7. Retry Count        (Assumes None)
                                        boolean  blXferDirIn,         //  8. Transfer Direction (Assumes In)
                                        boolean  blStatReq            //  9. Status Requested (Assumes No)
                                     ) 
                       {
                          return ( oNet.ExecDeviceCmnd( oDevAddr,     
                                                        oCmndBlock,   
                                                        oInputBlock,  
                                                        oOutputBlock, 
                                                        oStatusBlock, 
                                                        lTimeOut,     
                                                        lRetry,       
                                                        blXferDirIn,  
                                                        blStatReq     )
                                 );
                       }

                          // Read a Mode Page from the Device
    public    StorRet  ReadModePageCmnd( StorAddr oDevAddr,       //  1. Device Address
                                         ByteBlk  oInputBlock,    //  2. Input Buffer Byte Block
                                         long     lModePage       //  3. Mode Page 
                                       ) 
                       {
                          return ( oNet.ReadModePageCmnd( oDevAddr,     
                                                         oInputBlock,  
                                                         lModePage )
                                 );
                       }
                      // Write a Mode Page to the Device
    public    StorRet  WriteModePageCmnd( StorAddr oDevAddr,       //  1. Device Address
                                          ByteBlk  oOutputBlock,   //  2. Output Buffer Byte Block
                                          long     lModePage       //  3. Mode Page 
                                        ) 
                       {
                          return ( oNet.WriteModePageCmnd( oDevAddr,     
                                                           oOutputBlock,  
                                                           lModePage )
                                 );
                       }

                       // For Non Fixed Disk Devices
    public    StorRet  ReadDevice( StorAddr oDevAddr,                 //  1. Device Address 
                                   DataAddr oDataAddr,                //  2. Data Address
                                   ByteBlk  oInputBlock,              //  3. Input  Buffer Byte Block
                                   ByteBlk  oStatusBlock,             //  4. Status Buffer Byte Block
                                   long     lTimeOut,                 //  5. Timeout in Seconds (Assumes 60 ) 
                                   long     lRetry,                   //  6. Retry Count        (Assumes None)
                                   boolean  blStatReq                 //  7. Status Requested (Assumes No)
                                 ) 
                       {
                          return ( oNet.ReadDevice( oDevAddr,         
                                                    oDataAddr,        
                                                    oInputBlock,      
                                                    oStatusBlock,     
                                                    lTimeOut,         
                                                    lRetry,           
                                                    blStatReq    )
                                 );
                       }
                       // For Non Fixed Disk Devices
    public    StorRet  WriteDevice( StorAddr oDevAddr,                //  1. Device Address
                                    DataAddr oDataAddr,               //  2. Data Address
                                    ByteBlk  oOutputBlock,            //  3. Output Buffer Byte Block
                                    ByteBlk  oStatusBlock,            //  4. Status Buffer Byte Block
                                    long     lTimeOut,                //  5. Timeout in Seconds (Assumes 60 ) 
                                    long     lRetry,                  //  6. Retry Count        (Assumes None)
                                    boolean  blStatReq                //  7. Status Requested (Assumes No)
                                  ) 
                       {
                          return ( oNet.WriteDevice( oDevAddr,        
                                                     oDataAddr,       
                                                     oOutputBlock,    
                                                     oStatusBlock,    
                                                     lTimeOut,        
                                                     lRetry,          
                                                     blStatReq    )
                                 );
                       }
                       // For Fixed Disk Devices ( SCSI TYPE 0, NON Removable Media )
    public    StorRet  ReadPhysDisk( StorAddr oPhysDskAddr,           //  1. Physical Disk Address
                                     DataAddr oDataAddr,              //  2. Data Address
                                     ByteBlk  oInputBlock,            //  3. Input  Buffer Byte Block
                                     ByteBlk  oStatusBlock,           //  4. Status Buffer Byte Block
                                     long     lTimeOut,               //  5. Timeout in Seconds (Assumes 60 ) 
                                     long     lRetry,                 //  6. Retry Count        (Assumes None)
                                     boolean  blStatReq               //  7. Status Requested (Assumes No)
                                   ) 
                       {
                          return ( oNet.ReadPhysDisk( oPhysDskAddr,   
                                                      oDataAddr,      
                                                      oInputBlock,    
                                                      oStatusBlock,   
                                                      lTimeOut,       
                                                      lRetry,         
                                                      blStatReq    )
                                 );
                       }
 
                       // For Fixed Disk Devices ( SCSI TYPE 0, NON Removable Media )
    public    StorRet  WritePhysDisk( StorAddr oPhysDskAddr,          //  1. Physical Disk Address
                                      DataAddr oDataAddr,             //  2. Data Address
                                      ByteBlk  oOutputBlock,          //  3. Output Buffer Byte Block
                                      ByteBlk  oStatusBlock,          //  4. Status Buffer Byte Block
                                      long     lTimeOut,              //  5. Timeout in Seconds (Assumes 60 ) 
                                      long     lRetry,                //  6. Retry Count        (Assumes None)
                                      boolean  blStatReq              //  7. Status Requested (Assumes No)
                                    ) 
                       {
                          return ( oNet.WritePhysDisk( oPhysDskAddr,  
                                                       oDataAddr,     
                                                       oOutputBlock,  
                                                       oStatusBlock,  
                                                       lTimeOut,      
                                                       lRetry,        
                                                       blStatReq    )
                                 );
                       }
 //
 //                    StorageCmnd Monitor Access Methods
 //
    public    StorRet  MonitorAdapterStatistics( StorAddr oAdapAddr, boolean blEnableAdapStats ) 
                       {
                          return ( oNet.MonitorAdapterStatistics( oAdapAddr, blEnableAdapStats ) );
                       }
 
    public    StorRet  MonitorDeviceStatistics( StorAddr oDevAddr, boolean blEnableDevStats ) 
                       {
                          return ( oNet.MonitorDeviceStatistics( oDevAddr, blEnableDevStats ) );
                       }
 
    public    StorRet  GetAdapterStatistics( StorAddr oAdapAddr, AdapterStatistics oAdapStats ) 
                       {
                          return ( oNet.GetAdapterStatistics( oAdapAddr, oAdapStats ) );
                       }
 
    public    StorRet  GetDeviceStatistics( StorAddr oDevAddr, PhysicalDeviceStatistics oPhysDevStats ) 
                       {
                          return ( oNet.GetDeviceStatistics( oDevAddr, oPhysDevStats ) );
                       }
 
    public    StorRet  GetSafteCount( StorAddr oChanAddr, IVal iSafteCount, AddrList oDevAddrList ) 
                       {
                          return ( oNet.GetSafteCount( oChanAddr, iSafteCount, oDevAddrList ) );
                       }
 
    public    StorRet  GetSafteConfig( StorAddr oDevAddr, SafteConfig oSafteConfig ) 
                       {
                          return ( oNet.GetSafteConfig( oDevAddr, oSafteConfig ) );
                       }
 
    public    StorRet  GetSafteStatus( StorAddr oDevAddr, SafteStatus oSafteStatus ) 
                       {
                          return ( oNet.GetSafteStatus( oDevAddr, oSafteStatus ) );
                       }
 //ͻ
 //͹
 //                                              RaidCmnd Methods                                                     
 //͹
 //ͼ
    public    StorRet  IsRaidPresent( BlVal oblPresent )              // Is there  one or more supported
                       {
                          return ( oNet.IsRaidPresent( oblPresent ) );
                       }
                                                                      // Raid Adapters present and useable
    public    int      GetRaidIntfVersion( Version oVersion )         // Do NOT override this method
                       {
                          return ( oNet.GetRaidIntfVersion( oVersion ) );  
                       }
 //
 //                    RaidCmnd Configuration Access Methods
 //
                       // 50 = Low, 100 = Medium, 150 = High
    public    StorRet  SetRebuildPriority( StorAddr oAdapAddr, short sPriorityLevel ) 
                       {
                          return ( oNet.SetRebuildPriority( oAdapAddr, sPriorityLevel ) );
                       }

    public    StorRet  SetAttendanceMode( StorAddr oAdapAddr, boolean blAttended ) 
                       {
                          return ( oNet.SetAttendanceMode( oAdapAddr, blAttended ) );
                       }

    public    StorRet  SetReadAheadMode( StorAddr oAdapAddr, boolean blReadAhead ) 
                       {
                          return ( oNet.SetReadAheadMode( oAdapAddr, blReadAhead ) );
                       }

    public    StorRet  SetStripeSliceSize( StorAddr oAdapAddr, long lStripePortionSize ) 
                       {
                          return ( oNet.SetStripeSliceSize( oAdapAddr, lStripePortionSize ) );
                       }

    public    StorRet  GetAdapterRaidConfig( StorAddr oAdapAddr, ByteBlk oConfig ) 
                       {
                          return ( oNet.GetAdapterRaidConfig( oAdapAddr, oConfig ) );
                       }

    public    StorRet  ResetAdapterRaidConfig( StorAddr oAdapAddr ) 
                       {
                          return ( oNet.ResetAdapterRaidConfig( oAdapAddr ) );
                       }

    public    StorRet  SetAdapterRaidConfig( StorAddr oAdapAddr, ByteBlk oConfig ) 
                       {
                          return ( oNet.SetAdapterRaidConfig( oAdapAddr, oConfig ) );
                       }

                      // If solo device specified, addr struct must also have channel & device ID for drive
    public    StorRet  SetAdapterRaidConfigFromDevice( StorAddr oAdapAddr, boolean blSoloDevice ) 
                       {
                          return ( oNet.SetAdapterRaidConfigFromDevice( oAdapAddr, blSoloDevice ) );
                       }

    public    StorRet  SetWritePolicy( StorAddr oVirtDevAddr, short sWriteMethod ) 
                       {
                          return ( oNet.SetWritePolicy( oVirtDevAddr, sWriteMethod ) );
                       }

    public    StorRet  DuplicateVirtDev( StorAddr oFromVirtDevAddr, StorAddr oToVirtDevAddr ) 
                       {
                          return ( oNet.DuplicateVirtDev( oFromVirtDevAddr, oToVirtDevAddr ) );
                       }
 //
 //                    RaidCmnd Adapter Access Methods
 //
                       // Return Raid adapter information
    public    StorRet  RaidAdapterInfo( StorAddr oAdapAddr, RaidAdapterInfo oRaidAdapInfo ) 
                       {
                          return ( oNet.RaidAdapterInfo( oAdapAddr, oRaidAdapInfo ) );
                       }

    public    StorRet  GetAdapterEventLog( StorAddr oAdapAddr, ByteBlk oEventLog, short sEventLogType ) 
                       {
                          return ( oNet.GetAdapterEventLog( oAdapAddr, oEventLog, sEventLogType ) );
                       }

    public    StorRet  EraseAdapterEventLog( StorAddr oAdapAddr, short sEventLogType ) 
                       {
                          return ( oNet.EraseAdapterEventLog( oAdapAddr, sEventLogType ) );
                       }

    public    StorRet  CreateArray( StorAddr oAdapAddr, AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.CreateArray( oAdapAddr, oPhysDevAddrList ) );
                       }

    public    StorRet  DeleteArray( StorAddr oAdapAddr, int iArrayNum ) 
                       {
                          return ( oNet.DeleteArray( oAdapAddr, iArrayNum ) );
                       }

    public    StorRet  GetArrayCount( StorAddr oAdapAddr, AddrList oArrayAddrList ) 
                       {
                          return ( oNet.GetArrayCount( oAdapAddr, oArrayAddrList ) );
                       }

    public    StorRet  GetArrayVirtDevCount( StorAddr oArrayAddr, AddrList oVirtDevAddrList ) 
                       {
                          return ( oNet.GetArrayVirtDevCount( oArrayAddr, oVirtDevAddrList ) );
                       }

    public    StorRet  GetArrayPhysDevCount( StorAddr oArrayAddr, AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.GetArrayPhysDevCount( oArrayAddr, oPhysDevAddrList ) );
                       }

    public    StorRet  ArrayInfo( StorAddr oArrayAddr, RaidArrayInfo oArrayInfo ) 
                       {
                          return ( oNet.ArrayInfo( oArrayAddr, oArrayInfo ) );
                       }

    public    StorRet  HotSwapRebuild( StorAddr oAdapAddr, boolean blEnableHotSwapRebuild ) 
                       {
                          return ( oNet.HotSwapRebuild( oAdapAddr, blEnableHotSwapRebuild ) );
                       }

    public    StorRet  AdapterDeviceScan( StorAddr oAdapaddr, IVal oiPhysDevicesFound ) 
                       {
                          return ( oNet.AdapterDeviceScan( oAdapaddr, oiPhysDevicesFound ) );
                       }

    public    StorRet  SetHostConfigId( StorAddr oAdapAddr, ByteBlk oConfigIdNullTerm ) 
                       {
                          return ( oNet.SetHostConfigId( oAdapAddr, oConfigIdNullTerm ) );
                       }

    public    StorRet  ClearClusterPartnerId( StorAddr oAdapAddr ) 
                       {
                          return ( oNet.ClearClusterPartnerId( oAdapAddr ) );
                       }

    public    StorRet  SetClusterPartnerId( StorAddr oAdapAddr, ByteBlk oPartnerIdNullTerm ) 
                       {
                          return ( oNet.SetClusterPartnerId( oAdapAddr, oPartnerIdNullTerm ) );
                       }
 //
 //                    RaidCmnd Virtual Device Access Methods
 //
                       // Get the VIRTUAL device count for the specified Adapter
    public    StorRet  GetVirtDevCount(  StorAddr oAdapAddr, AddrList oVirtDevAddrList ) 
                       {
                          return ( oNet.GetVirtDevCount( oAdapAddr, oVirtDevAddrList ) );
                       }

    public    StorRet  CreateVirtDev( StorAddr oVirtDevAddr, int iRaidLevel, long lMegaByteSize, long lVirtDevParms,
                                      AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.CreateVirtDev( oVirtDevAddr, iRaidLevel, lMegaByteSize, lVirtDevParms,
                                                       oPhysDevAddrList ) );
                       }
    public    StorRet  DeleteVirtDev( StorAddr oVirtDevAddr ) 
                       {
                          return ( oNet.DeleteVirtDev( oVirtDevAddr ) );
                       }

    public    StorRet  SynchronizeVirtDev( StorAddr oVirtDevAddr, short sSynchMode ) 
                       {
                          return ( oNet.SynchronizeVirtDev( oVirtDevAddr, sSynchMode ) );
                       }

    public    StorRet  CheckSynchronizeVirtDevProgress( StorAddr oVirtDevAddr, SVal osPercent ) 
                       {
                          return ( oNet.CheckSynchronizeVirtDevProgress( oVirtDevAddr, osPercent ) );
                       }

    public    StorRet  InitializeVirtDev( StorAddr oVirtDevAddr, short sInitializeMode ) 
                       {
                          return ( oNet.InitializeVirtDev( oVirtDevAddr, sInitializeMode ) );
                       }

    public    StorRet  CheckInitializeVirtDevProgress( StorAddr oVirtDevAddr, SVal osPercent ) 
                       {
                          return ( oNet.CheckInitializeVirtDevProgress( oVirtDevAddr, osPercent ) );
                       }

    public    StorRet  MigrateVirtDev( StorAddr oOldVirtDevAddr, StorAddr oNewVirtDevAddr ) 
                       {
                          return ( oNet.MigrateVirtDev( oOldVirtDevAddr, oNewVirtDevAddr ) );
                       }

    public    StorRet  CheckMigrateVirtDevProgress( StorAddr oVirtDevAddr, SVal osPercent ) 
                       {
                          return ( oNet.CheckMigrateVirtDevProgress( oVirtDevAddr, osPercent ) );
                       }

    public    StorRet  IncreaseArraySize( StorAddr oArrayAddr, ArraySize oNewArraySize, AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.IncreaseArraySize( oArrayAddr, oNewArraySize, oPhysDevAddrList ) );
                       }

    public    StorRet  ModifyArrayRaidLevel( StorAddr oArrayAddr, short sNewRaidLevel, AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.ModifyArrayRaidLevel( oArrayAddr, sNewRaidLevel, oPhysDevAddrList ) );
                       }

    public    StorRet  IncreaseVirtDevSizes( StorAddr oVirtDevAddr, DeviceSize oNewVirtDevSize, AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.IncreaseVirtDevSizes( oVirtDevAddr, oNewVirtDevSize, oPhysDevAddrList ) );
                       }

    public    StorRet  ModifyVirtDevRaidLevel( StorAddr oVirtDevAddr, short sNewRaidLevel, AddrList oPhysDevAddrList ) 
                       {
                          return ( oNet.ModifyVirtDevRaidLevel( oVirtDevAddr, sNewRaidLevel, oPhysDevAddrList ) );
                       }

                       // Get the device capacity for the specified device
    public    StorRet  GetVirtDevSize( StorAddr oVirtDevAddr, DeviceSize oVirtDevSize ) 
                       {
                          return ( oNet.GetVirtDevSize( oVirtDevAddr, oVirtDevSize ) );
                       }

    public    StorRet  GetVirtDevInfo( StorAddr oVirtDevAddr, VirtualDeviceInfo oVirtDevInfo ) 
                       {
                          return ( oNet.GetVirtDevInfo( oVirtDevAddr, oVirtDevInfo ) );
                       }

    public    StorRet  UnBlockVirtDev( StorAddr oVirtDevAddr ) 
                       {
                          return ( oNet.UnBlockVirtDev( oVirtDevAddr ) );
                       }

    public    StorRet  ClearMergeGroupId( StorAddr oVirtDevAddr ) 
                       {
                          return ( oNet.ClearMergeGroupId( oVirtDevAddr ) );
                       }

    public    StorRet  SetMergeGroupId( StorAddr oVirtDevAddr, short sMergeGroupId, boolean blSharedDev ) 
                       {
                          return ( oNet.SetMergeGroupId( oVirtDevAddr, sMergeGroupId, blSharedDev ) );
                       }

                       // For RAID Logical Drives
    public    StorRet  ReadVirtDevice( StorAddr oVirtDevAddr,         //  1. Virtual Drive Address
                                       DataAddr oDataAddr,            //  2. Data Address
                                       ByteBlk  oInputBlock,          //  3. Input  Buffer Byte Block
                                       ByteBlk  oStatusBlock,         //  4. Status Buffer Byte Block
                                       long     lTimeOut,             //  5. Timeout in Seconds (Assumes 60 ) 
                                       long     lRetry,               //  6. Retry Count        (Assumes None)
                                       boolean  blStatReq             //  7. Status Requested (Assumes No)
                                     ) 
                       {
                          return ( oNet.ReadVirtDevice( oVirtDevAddr,     
                                                        oDataAddr,        
                                                        oInputBlock,      
                                                        oStatusBlock,     
                                                        lTimeOut,         
                                                        lRetry,           
                                                        blStatReq    )
                                 );
                       }

                       // For RAID Logical Drives
    public    StorRet  WriteVirtDevice( StorAddr oVirtDevAddr,        //  1. Virtual Drive Address
                                        DataAddr oDataAddr,           //  2. Data Address
                                        ByteBlk  oOutputBlock,        //  3. Output Buffer Byte Block
                                        ByteBlk  oStatusBlock,        //  4. Status Buffer Byte Block
                                        long     lTimeOut,            //  5. Timeout in Seconds (Assumes 60 ) 
                                        long     lRetry,              //  6. Retry Count        (Assumes None)
                                        boolean  blStatReq            //  7. Status Requested (Assumes No)
                                      ) 
                       {
                          return ( oNet.WriteVirtDevice( oVirtDevAddr,    
                                                         oDataAddr,       
                                                         oOutputBlock,    
                                                         oStatusBlock,    
                                                         lTimeOut,        
                                                         lRetry,          
                                                         blStatReq    )
                                 );
                       }
 //
 //                    RaidCmnd Physical Device Access Methods
 //
    public    StorRet  AddPhysDev( StorAddr oPhysDevAddr, short sPhysDevSate ) 
                       {
                          return ( oNet.AddPhysDev( oPhysDevAddr, sPhysDevSate ) );
                       }

    public    StorRet  RemovePhysDev( StorAddr oPhysDevAddr ) 
                       {
                          return ( oNet.RemovePhysDev( oPhysDevAddr ) );
                       }

    public    StorRet  ReplacePhysDev( StorAddr oPhysDevAddr ) 
                       {
                          return ( oNet.ReplacePhysDev( oPhysDevAddr ) );
                       }

    public    StorRet  StartPhysDev( StorAddr oPhysDevAddr ) 
                       {
                          return ( oNet.StartPhysDev( oPhysDevAddr ) );
                       }

    public    StorRet  StopPhysDev( StorAddr oPhysDevAddr ) 
                       {
                          return ( oNet.StopPhysDev( oPhysDevAddr ) );
                       }

    public    StorRet  GetPhysDevState( StorAddr oPhysDevAddr, SVal osPhysDevSate ) 
                       {
                          return ( oNet.GetPhysDevState( oPhysDevAddr, osPhysDevSate ) );
                       }

    public    StorRet  SetPhysDevState( StorAddr oPhysDevAddr, short sPhysDevSate ) 
                       {
                          return ( oNet.SetPhysDevState( oPhysDevAddr, sPhysDevSate ) );
                       }

    public    StorRet  RebuildPhysDev( StorAddr oPhysDevAddr ) 
                       {
                          return ( oNet.RebuildPhysDev( oPhysDevAddr ) );
                       }

    public    StorRet  RebuildPhysDevToOtherDev( StorAddr oOldPhysDevAddr, StorAddr oNewPhysDevAddr ) 
                       {
                          return ( oNet.RebuildPhysDevToOtherDev( oOldPhysDevAddr, oNewPhysDevAddr ) );
                       }

    public    StorRet  CheckRebuildProgress( StorAddr oVirtDevAddr, SVal osPercent, SVal osStatus ) 
                       {
                          return ( oNet.CheckRebuildProgress( oVirtDevAddr, osPercent, osStatus ) );
                       }

    public    StorRet  GetPhysDevEventLog( StorAddr oPhysDevAddr, ByteBlk oEventLog, short sEventLogType ) 
                       {
                          return ( oNet.GetPhysDevEventLog( oPhysDevAddr, oEventLog, sEventLogType ) );
                       }

    public    StorRet  ErasePhysDevEventLog( StorAddr oPhysDevAddr, short sEventLogType ) 
                       {
                          return ( oNet.ErasePhysDevEventLog( oPhysDevAddr, sEventLogType ) );
                       }
 //
 //                    RaidCmnd Monitor Access Methods
 //
    public    StorRet  MonitorRaidStatistics( StorAddr oAdapAddr, boolean blEnableRaidStats ) 
                       {
                          return ( oNet.MonitorRaidStatistics( oAdapAddr, blEnableRaidStats ) );
                       }

    public    StorRet  GetRaidStatistics( StorAddr oAdapAddr, ByteBlk oRaidStats ) 
                       {
                          return ( oNet.GetRaidStatistics( oAdapAddr, oRaidStats ) );
                       }

    public    StorRet  GetVirtDevStatistics( StorAddr oVirtDevAddr, VirtualDeviceStatistics oVirtDevStats ) 
                       {
                          return ( oNet.GetVirtDevStatistics( oVirtDevAddr, oVirtDevStats ) );
                       }
 //ͻ
 //͹
 //                                            SubSystemCmnd Methods                                                  
 //͹
 //ͼ
    public    StorRet  IsSubSystemPresent( BlVal oblPresent )        // Is there one or more supported
                       {
                          return ( oNet.IsSubSystemPresent( oblPresent ) ); 
                       }
                                                                     // SubSystems present and useable
    public    int      GetSubSysIntfVersion( Version oVersion )      // Do NOT override this method
                       {
                          return( oNet.GetSubSysIntfVersion( oVersion ) );    
                       }
 //
 //                    SubSystemCmnd Configuration Access Methods
 //
    public    StorRet  GetSubSystemConfig( StorAddr oSubSysAddr, ByteBlk oConfig ) 
                       {
                          return( oNet.GetSubSystemConfig( oSubSysAddr, oConfig ) );
                       }

    public    StorRet  SetSubSystemConfig( StorAddr oSubSysAddr, ByteBlk oConfig ) 
                       {
                          return( oNet.SetSubSystemConfig( oSubSysAddr, oConfig ) );
                       }

                       // Execute SubSystem Diagnostics
    public    StorRet  ExecuteSubSystemDiagnostics( StorAddr oSubSysAddr, long lDiagTestNum, long lLoopCount ) 
                       {
                          return( oNet.ExecuteSubSystemDiagnostics( oSubSysAddr, lDiagTestNum, lLoopCount ) );
                       }
 //
 //                    SubSystemCmnd Adapter Access Methods
 //
                       // Get SubSystem Count
    public    StorRet  SupportedSubSystemCount(  StorAddr oSystemAddr, AddrList oSubSysAddrList ) 
                       {
                          return( oNet.SupportedSubSystemCount( oSystemAddr, oSubSysAddrList ) );
                       }

                       // Return Subsystem Status
    public    StorRet  SubSystemStatus( StorAddr oSubSysAddr, SubSystemStatus oSubSysStatus ) 
                       {
                          return( oNet.SubSystemStatus( oSubSysAddr, oSubSysStatus ) );
                       }

                       // Return Subsystem Info
    public    StorRet  SubSystemInfo( StorAddr oSubSysAddr, SubSystemInfo oSubSysInfo ) 
                       {
                          return( oNet.SubSystemInfo( oSubSysAddr, oSubSysInfo ) );
                       }

                       // Return Loop Info
    public    StorRet  LoopInfo( StorAddr oSubSysAddr, LoopInfo oLoopInfo ) 
                       {
                          return( oNet.LoopInfo( oSubSysAddr, oLoopInfo ) );
                       }

                       // Update Adapter BIOS
    public    StorRet  UpdateSubSystemBios( StorAddr oSubSysAddr, ByteBlk oBiosData ) 
                       {
                          return( oNet.UpdateSubSystemBios( oSubSysAddr, oBiosData ) );
                       }

                       // Update Adapter Firmware
    public    StorRet  UpdateSubSystemFirmWare( StorAddr oSubSysAddr, ByteBlk oFirmWareData ) 
                       {
                          return( oNet.UpdateSubSystemFirmWare( oSubSysAddr, oFirmWareData ) );
                       }

    public    StorRet  GetSubSystemEventLog( StorAddr oSubSysAddr, ByteBlk oEventLog, short sEventLogType ) 
                       {
                          return( oNet.GetSubSystemEventLog( oSubSysAddr, oEventLog, sEventLogType ) );
                       }

    public    StorRet  EraseSubSystemEventLog( StorAddr oSubSysAddr, short sEventLogType ) 
                       {
                          return( oNet.EraseSubSystemEventLog( oSubSysAddr, sEventLogType ) );
                       }

                       // Sends a Generic Command to the SubSystem
    public    StorRet  ExecSubSystemCmnd( StorAddr oSubSysAddr,       //  1. SubSystem Address
                                          CmndBlk  oCmndBlock,        //  2. Device Command Byte Block 
                                          ByteBlk  oInputBlock,       //  3. Input  Buffer Byte Block
                                          ByteBlk  oOutputBlock,      //  4. Output Buffer Byte Block
                                          ByteBlk  oStatusBlock,      //  5. Status Buffer Byte Block
                                          long     lTimeOut,          //  6. Timeout in Seconds (Assumes 60 ) 
                                          long     lRetry,            //  7. Retry Count        (Assumes None)
                                          boolean  blXferDirIn,       //  8. Transfer Direction (Assumes In)
                                          boolean  blStatReq          //  9. Status Requested (Assumes No)
                                        ) 
                       {
                          return( oNet.ExecSubSystemCmnd( oSubSysAddr,     
                                                          oCmndBlock,      
                                                          oInputBlock,     
                                                          oOutputBlock,    
                                                          oStatusBlock,    
                                                          lTimeOut,        
                                                          lRetry,          
                                                          blXferDirIn,     
                                                          blStatReq    )
                                );
                       }
 //
 //                    SubSystemCmnd Physical Device Access Methods ( For Devices attached directly to loop )
 //
    public    StorRet  SubSystemDeviceType( StorAddr oSubSysDevAddr, SVal osDevType ) 
                       {
                          return( oNet.SubSystemDeviceType( oSubSysDevAddr, osDevType ) );
                       }

                       // Get the device capacity for the specified device
    public    StorRet  SubSystemDeviceCapacity( StorAddr oSubSysDevAddr, DeviceSize oSubSysDevSize ) 
                       {
                          return( oNet.SubSystemDeviceCapacity( oSubSysDevAddr, oSubSysDevSize ) );
                       }

                       // Return Device Info
    public    StorRet  SubSystemDeviceInfo( StorAddr oSubSysDevAddr, DeviceInfo oDevInfo ) 
                       {
                          return( oNet.SubSystemDeviceInfo( oSubSysDevAddr, oDevInfo ) );
                       }
 //
 //                SubSystemCmnd Monitor Access Methods
 //
    public    StorRet  MonitorSubSystemStatistics( StorAddr oSubSysAddr, boolean blEnableSubSysStats ) 
                       {
                          return( oNet.MonitorSubSystemStatistics( oSubSysAddr, blEnableSubSysStats ) );
                       }

    public    StorRet  GetSubSystemStatistics( StorAddr oSubSysAddr, ByteBlk oSubSysStats ) 
                       {
                          return( oNet.GetSubSystemStatistics( oSubSysAddr, oSubSysStats ) );
                       }
}
